import * as db from "./db";
import ProgramItem from "./ProgramItem";
export default class Program {
    static get(id: number): ProgramItem;
    static exists(id: number): boolean;
    static findByQuery(query: object): ProgramItem[];
    static findByServiceId(serviceId: number): ProgramItem[];
    static all(): ProgramItem[];
    private _itemMap;
    private _saveTimerId;
    private _programGCInterval;
    constructor();
    /** CAUTION: This getter method creates a new Array object every time. */
    get items(): ProgramItem[];
    private get _itemIterator();
    add(item: ProgramItem, firstAdd?: boolean): void;
    get(id: number): ProgramItem | null;
    remove(item: ProgramItem): void;
    exists(id: number): boolean;
    findByQuery(query: object): ProgramItem[];
    findByServiceId(serviceId: number): ProgramItem[];
    findConflicts(networkId: number, serviceId: number, start: number, end: number): ProgramItem[];
    findByNetworkIdAndReplace(networkId: number, programs: db.Program[]): void;
    save(): void;
    private _load;
    private _save;
    private _collectDBData;
    private _gc;
}
