"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common = require("./common");
const _1 = require("./_");
const Event_1 = require("./Event");
class ProgramItem {
    constructor(data) {
        this.data = data;
        if (!data.id) {
            data.id = ProgramItem.getId(data.networkId, data.serviceId, data.eventId);
        }
    }
    static getId(networkId, serviceId, eventId) {
        return parseInt(networkId + (serviceId / 100000).toFixed(5).slice(2) + (eventId / 100000).toFixed(5).slice(2), 10);
    }
    get id() {
        return this.data.id;
    }
    get service() {
        return _1.default.service.get(this.data.networkId, this.data.serviceId);
    }
    update(data) {
        if (common.updateObject(this.data, data) === true) {
            _1.default.program.save();
            Event_1.default.emit("program", "update", this.data);
        }
    }
    getStream(user) {
        return _1.default.tuner.getProgramStream(this, user);
    }
}
exports.default = ProgramItem;
//# sourceMappingURL=ProgramItem.js.map