/// <reference types="node" />
import * as stream from "stream";
interface StreamOptions extends stream.DuplexOptions {
    readonly networkId?: number;
    readonly serviceId?: number;
    readonly eventId?: number;
    readonly noProvide?: boolean;
    readonly parseNIT?: boolean;
    readonly parseSDT?: boolean;
    readonly parseEIT?: boolean;
}
export default class TSFilter extends stream.Duplex {
    private _provideServiceId;
    private _provideEventId;
    private _parseNIT;
    private _parseSDT;
    private _parseEIT;
    private _targetNetworkId;
    private _parser;
    private _packet;
    private _offset;
    private _buffer;
    private _parses;
    private _patsec;
    private _closed;
    private _ready;
    private _providePids;
    private _parsePids;
    private _tsid;
    private _patCRC;
    private _serviceIds;
    private _parseServiceIds;
    private _pmtPid;
    private _pmtTimer;
    private _streamTime;
    private _epgReady;
    private _epgState;
    private _overflowTimer;
    private _provideEventLastDetectedAt;
    private _provideEventTimeout;
    private highWaterMark;
    private _overflowTimeLimit;
    /** Number divisible by a multiple of 188 */
    private _maxBufferBytesBeforeReady;
    private _eventEndTimeout;
    private _readableState;
    constructor(options: StreamOptions);
    _read(size: number): void;
    _write(chunk: Buffer, encoding: string, callback: Function): void;
    private _processPacket;
    private _onPAT;
    private _onPMT;
    private _onNIT;
    private _onSDT;
    private _onEIT;
    private _onTOT;
    private _onCDT;
    private _observeProvideEvent;
    private _updateEpgState;
    private _close;
}
export {};
