"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const api = require("../api");
const Tuner_1 = require("../Tuner");
exports.get = (req, res) => {
    api.responseJSON(res, Tuner_1.default.all().map(device => device.export()));
};
exports.get.apiDoc = {
    tags: ["tuners"],
    operationId: "getTuners",
    responses: {
        200: {
            description: "OK",
            schema: {
                type: "array",
                items: {
                    $ref: "#/definitions/TunerDevice"
                }
            }
        },
        default: {
            description: "Unexpected Error",
            schema: {
                $ref: "#/definitions/Error"
            }
        }
    }
};
//# sourceMappingURL=tuners.js.map