"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const api = require("../../api");
const Tuner_1 = require("../../Tuner");
exports.parameters = [
    {
        in: "path",
        name: "index",
        type: "integer",
        minimum: 0,
        required: true
    }
];
exports.get = (req, res) => {
    const tuner = Tuner_1.default.get(req.params.index);
    if (tuner === null) {
        api.responseError(res, 404);
        return;
    }
    api.responseJSON(res, tuner.export());
};
exports.get.apiDoc = {
    tags: ["tuners"],
    operationId: "getTuner",
    responses: {
        200: {
            description: "OK",
            schema: {
                $ref: "#/definitions/TunerDevice"
            }
        },
        404: {
            description: "Not Found",
            schema: {
                $ref: "#/definitions/Error"
            }
        },
        default: {
            description: "Unexpected Error",
            schema: {
                $ref: "#/definitions/Error"
            }
        }
    }
};
//# sourceMappingURL={index}.js.map