import * as common from "./common";
import * as log from "./log";
export interface Server {
    readonly path?: string;
    readonly port?: number;
    /** `true` to disable IPv6 listening */
    readonly disableIPv6?: boolean;
    readonly logLevel?: log.LogLevel;
    readonly maxLogHistory?: number;
    /** Byte */
    readonly highWaterMark?: number;
    /** Milliseconds */
    readonly overflowTimeLimit?: number;
    readonly maxBufferBytesBeforeReady?: number;
    readonly eventEndTimeout?: number;
    readonly programGCInterval?: number;
    readonly epgGatheringInterval?: number;
    readonly epgRetrievalTime?: number;
}
export interface Tuner {
    readonly name: string;
    readonly types: common.ChannelType[];
    readonly command?: string;
    readonly dvbDevicePath?: string;
    readonly remoteMirakurunHost?: string;
    readonly remoteMirakurunPort?: number;
    readonly remoteMirakurunDecoder?: boolean;
    readonly decoder?: string;
    readonly isDisabled?: boolean;
}
export interface Channel {
    readonly name: string;
    readonly type: common.ChannelType;
    readonly channel: string;
    readonly satelite?: string;
    readonly space?: number;
    readonly serviceId?: number;
    readonly isDisabled?: boolean;
}
export declare function loadServer(): Server;
export declare function saveServer(data: Server): Promise<void>;
export declare function loadTuners(): Tuner[];
export declare function saveTuners(data: Tuner[]): Promise<void>;
export declare function loadChannels(): Channel[];
export declare function saveChannels(data: Channel[]): Promise<void>;
